from __future__ import print_function
import argparse
import logging

parser   = argparse.ArgumentParser()
add      = parser.add_argument
defaults = parser.set_defaults
parse    = parser.parse_args

add("--mpi_ni", type=int, default=1, help="number of x processors")
add("--mpi_nj", type=int, default=1, help="number of y processors")
add("--hydrostatic", action='store_true')
add("--llm", type=int)
add("--dt", type=float, help='Time step in seconds')
add("--debug", default=[], type=lambda str : str.split(','), 
    help='Comma-separated list of modules that will display debug information')

def noop(*args, **kwargs): pass

def ignore_first(fun):
    def f(self, *args, **kwargs) : fun(*args, **kwargs)
    return f

class Logger:
    debug, info, error = [ ignore_first(fun) for fun in 
                           logging.info, logging.warning, logging.error ]
    def __init__(self, modulename):
        arglist = parser.parse_args()
        if modulename not in arglist.debug :
            self.debug = noop
        else:
            print('Debug ON for module %s'%modulename)
        config_log()

def config_log(*args, **kwargs):
    logging.basicConfig(level='INFO', *args, **kwargs)
